package poo;

import poo.util.Dispositivo;
import poo.util.Leitura;
import poo.util.ManipuladorDeArquivos;


/**
 *
 * @author Seu Nome
 */
public class Simulador {

   // Vetor com todos os dispositivos que compoem a rede
   private Dispositivo rede[];
   // indica quantos dispositivos de cada tipo fazem parte da rede
   private int totalDeComputadores;
   private int totalDeSwitchs;
   private int totalDeHubs;
   private int totalDeDispositivos;

   public Simulador(int tComputadores, int tSwitchs, int tHubs) {
      this.totalDeComputadores = tComputadores;
      this.totalDeSwitchs = tSwitchs;
      this.totalDeHubs = tHubs;
      this.totalDeDispositivos = tComputadores + tSwitchs + tHubs;
      this.rede = new Dispositivo[totalDeDispositivos];
   }

   public void executar(String nomeDoArquivo) {
      boolean aindaTemPacote;

      /*-----------------------------------------------------------------*/
      // colocar aqui o codigo para montar a topologia


      /*-----------------------------------------------------------------*/

      //carregando o trafego
      ManipuladorDeArquivos.carregarTrafego(nomeDoArquivo, this.rede);


      //iniciando a simulacao
      // vai repetir a simulacao ate' que nenhum dispositivo tenha pacotes em
      // sua fila
      do {
         //executa o processamento para cada dispositivo
         for (int i = 0; i < rede.length; i++) {
            if (rede[i] != null) {
               rede[i].processar();
            }
         }

         aindaTemPacote = false;
         //verifica se algum dispositivo ainda tem pacote na fila para ser processado
         for (int i = 0; i < rede.length; i++) {
            if (!rede[i].filaVazia()) {
               aindaTemPacote = true;
            }
         }
      } while (aindaTemPacote);

      // imprime o resultado da simulacao
      this.imprimeResultado();

   }

   /**
    * Imprime a contabilizacao de pacotes processados e descartados por cada
    * dispositivo
    */
   private void imprimeResultado() {
      for (int i = 0; i < rede.length; i++) {
         if (rede[i] != null) {
            System.out.println(rede[i].toString());
         }
      }
   }

   public static void main(String[] args) {
      // Se desejar gerar um arquivo com trafego
      // ManipuladorDeArquivos.gerarTrafego(nomeDoArquivo, totalDeComputadores, totalDePacotes);

      // Simulador sim = new Simulador(tComputadores, tSwitchs, tHubs);
      // sim.executar(nomeDoArquivo);
   }
}
