package poo.util;

import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Esta classe tem por objetivo facilitar a leitura via teclado
 *
 * @author Emerson Ribeiro de Mello
 */
public abstract class Leitura {

   /**
    * Le informacoes no dispositivo de entrada padrao e retorna um inteiro
    * @return inteiro obtido atraves do dispositivo de entrada padrao
    */
   public static int lerTeclado() {
      int ler;
      try {
         ler = new Integer(lerTecladoString()).intValue();
      } catch (Exception ex) {
         ler = -1;
         System.err.println("Erro ao converter String para int: " + ex.toString());
      }
      return ler;
   }

   /**
    * Obtem informacoes do dispositivo de entrada padrao e retorna uma String
    * @return String obtida atraves do dispositivo de entrada padrao
    */
   public static String lerTecladoString() {
      BufferedReader teclado;
      String ler;

      teclado = new BufferedReader(new InputStreamReader(System.in));

      try {
         ler = teclado.readLine();
      } catch (Exception exception) {
         System.err.println("Erro: " + exception.toString());
         // retorna -1 no caso de erro na leitura
         return "-1";
      }
      return ler;
   }
}//fim da classe

